module CYCSRS.Encoding 
  (module CYCSRS.Encoding.Shift
  ,module CYCSRS.Encoding.Split
  ,module CYCSRS.Encoding.Rotate
  ,module CYCSRS.Encoding.SRS2CYC
  ,encodings
  ,getEncoding
  ,getEncodings
  ,showEncodings
  ,Encoding(..)
  ,encodingInfix
  )  
  where
import Data.Maybe

import Data.List
import Data.Char
import CYCSRS.Types
import Debug.Trace
import CYCSRS.Encoding.Shift
import CYCSRS.Encoding.Split
import CYCSRS.Encoding.Rotate
import CYCSRS.Encoding.SRS2CYC

data Encoding = NONE | SPLIT | SHIFT | ROTATE | SRSCYC | SPLIT2
 deriving(Show,Eq)            

 
encodings = [(NONE,id)
            ,(SRSCYC,srs2cyc)
            ,(ROTATE,rotate2)
            ,(SPLIT,split)
            ,(SHIFT, shift3)
            ,(SPLIT2,split2)
             ]
             
getEncoding "SPLIT"  = Just SPLIT
getEncoding "SHIFT"  = Just SHIFT
getEncoding "ROTATE" = Just ROTATE
getEncoding "SRSCYC" = Just SRSCYC
getEncoding "NONE"   = Just NONE
getEncoding "split"  = Just SPLIT
getEncoding "shift"  = Just SHIFT
getEncoding "rotate" = Just ROTATE
getEncoding "srscyc" = Just SRSCYC
getEncoding "none"   = Just NONE
getEncoding "split2"   = Just SPLIT2
getEncoding _        = Nothing

encodingInfix NONE = ""
encodingInfix o = "-" ++ (map toLower $ show o)
                      
showEncodings :: String                      
showEncodings = concat . intersperse "|" . map show . map fst $ encodings

getEncodings xs = 
  let encs = map getEncoding xs 
  in
   if any (isNothing) encs
      then Nothing 
      else Just (map fromJust encs)
  
       
