module CYCSRS.Encoding.Rotate(rotate2,rotate) where

import CYCSRS.Encoding.Tools
import CYCSRS.Types
import Data.List

  
rotate2 :: CRS -> SRS 
rotate2 crs = 
  let alph = nub $ concat $ concatMap (\(a,b) -> [a,b]) crs
      fresh 1 = zip alph alph
      fresh 2 = freshI 'A' (map snd $ fresh 1) alph
      fresh 3 = freshI 'B' ((map snd $ fresh 1) ++ (map snd $ fresh 2)) alph
      fresh 4 = freshI 'C' (((map snd $ fresh 1) ++ (map snd $ fresh 2)) ++ (map snd $ fresh 3)) alph
      fresh 5 = freshI 'D' ((((map snd $ fresh 1) ++ (map snd $ fresh 2)) ++ (map snd $ fresh 3)) ++ (map snd $ fresh 4)) alph
      fresh 0 = freshI 'E' (((((map snd $ fresh 1) ++ (map snd $ fresh 2)) ++ (map snd $ fresh 3)) ++ (map snd $ fresh 4)) ++ (map snd $ fresh 5)) (["begin","end","rewrite","cut","guess","rotate","moveleft","goright","wait","finish", "finish2"]) 
        
      get i [] = error "<internal error>: get called with []"
      get i s = 
               case (lookup s $ fresh i) of
                Nothing -> (error $ "<internal error>: did not find fresh symbol for: " ++ (show s))
                Just x  -> x
  in     [ ([get 0 "begin", get 0 "end"], [get 0 "rewrite",get 0 "end"])]                                               -- 1
      ++ [ ([get 0 "begin", get 1 a], [get 0 "rotate",get 0 "cut", get 4 a,get 0"guess"]) | a <- alph]                  -- 2
      ++ [ ([get 0 "guess", get 1 a], [get 4 a, get 0 "guess"]) | a <- alph]                                            -- 3
      ++ [ ([get 0 "guess", get 1 a], [get 0 "moveleft", get 3 a, get 0 "wait"]) | a <- alph]                           -- 4
      ++ [ ([get 0 "guess",get 0 "end"], [get 0 "finish",get 0 "end"])]                                                 -- 5 
      ++ [ ([get 4 b,get 0 "moveleft", get 3 a], [get 0 "moveleft",get 3 a, get 2 b]) | a <- alph, b <- alph]           -- 6
      ++ [ ([get 0 "cut", get 0 "moveleft", get 3 a], [get 5 a, get 0 "cut", get 0 "goright"]) | a <- alph]             -- 7
      ++ [ ([get 0 "goright", get 2 a], [get 4 a, get 0 "goright"]) | a <- alph]                                        -- 8
      ++ [ ([get 0 "goright", get 0 "wait", get 1 a], [get 0 "moveleft", get 3 a,get 0 "wait"])| a <- alph]             -- 9
      ++ [ ([get 0 "goright",get 0 "wait",get 0 "end"], [get 0 "finish",get 0 "end"])]                                  -- 10
      ++ [ ([get 4 a,get 0 "finish"] , [get 0 "finish", get 1 a]) | a <- alph]                                          -- 11
      ++ [ ([get 0 "cut",get 0 "finish"],[get 0 "finish2"])  ]                                                          -- 12
      ++ [ ([get 5 a,get 0 "finish2"] , [get 0 "finish2", get 1 a]) | a <- alph]                                        -- 12'
      ++ [ ([get 0 "rotate",get 0 "finish2"],[get 0 "rewrite"])]                                                       -- 13
      ++ [(get 0 "rewrite":(map (get 1) l),get 0 "begin":(map (get 1) r )) | (l,r) <- crs]                              -- 14
  
  



rotate :: CRS -> SRS 
rotate crs = 
  let alph = nub $ concat $ concatMap (\(a,b) -> [a,b]) crs
      freshsym = fresh alph (["begin","end","rewrite","cut","guess","rotate","moveleft","goright","wait","finish"])
      get [] = error "<internal error>: get called with []"
      get s = 
               case (lookup s freshsym) of
                Nothing -> (error $ "<internal error>: did not find fresh symbol for: " ++ (show s))
                Just x  -> x
  in 
 
 [ ([get "begin", get "end"], [get "rewrite",get "end"])]
 ++
 [ ([get "begin", a], [get "rotate",get "cut", a,get "guess"]) | a <- alph]
  ++
   [([get "guess", a], [a, get "guess"]) | a <- alph]
   ++
  [([get "guess",a], [get "moveleft", a, get "wait"]) | a <- alph]
  ++
  [([get "guess",get "end"], [get "finish",get "end"])]
  ++
  [([b,get "moveleft",a], [get "moveleft",a,b]) | a <- alph, b <- alph]
  ++
  [([get "cut", get "moveleft",a], [a, get "cut", get "goright"]) | a <- alph]
  ++
  [([get "goright", a], [a, get "goright"]) | a <- alph]
  ++
  [([get "goright", get "wait", a], [get "moveleft",a,get "wait"])| a <- alph]
  ++
  [([get "goright",get "wait",get "end"], [get "finish",get "end"])
  ]
  ++
  [([a,get "finish"] , [get "finish",a]) | a <- alph]
  ++
  [([get "cut",get "finish"],[get "finish"]),([get "rotate",get "finish"],[get "rewrite"])]
  ++ [(get "rewrite":l,get "begin":r ) | (l,r) <- crs]
