module CYCSRS.Encoding.SRS2CYC(srs2cyc) where

import CYCSRS.Encoding.Tools
import CYCSRS.Types
import Data.List
 
srs2cyc :: SRS -> CRS 
srs2cyc crs = 
 let 
       alph = nub $ concat $ concatMap (\(a,b) -> [a,b]) crs
       maxnum   = maximum $ map (\(a,b) -> length a) crs
       freshsym = fresh alph (["R","E","L"] ++ [a | a <- alph])
       get [] = error "fresh with []"
       get s = case (lookup s freshsym) of
                Nothing -> (error $ "<internal error>: did not find fresh symbol for: " ++ (show s))
                Just x  -> x
 in
  [([get "R", get "E"],[get "L", get "E"])]
  ++
  [([a, get "L"],[get "L", get a]) | a <- alph]
  ++ 
  [([get "R", get a],[a,get "R"]) | a <- alph]
  ++
  [((l ++ [get "L"]),(r ++ [get "R"])) | (l,r) <- crs]

  
