#!/bin/bash
# CONFIGURATION
# -------------
#
# The whole configuration is controlled by this file. 
#
# DO NOT MODIFY OTHER FILES.
#
# Set the following paths/values to your local installation
#
#
# PATHS
# -----
#
# path to the binaries of your Java installation (JDK is required, JRE is not sufficient)

export JAVAPATH=/usr/bin

# path to the folder that contains the minisat binary (the binary must be named minisat)

export MINISATPATH=/home/sabel/workspace/snd/papersOfKIST/cycsrs/program/CYCSRS/ExternalTools/minisat

# path to the folder that contains the yices binary (the binary must be named yices)

export YICESPATH=/home/sabel/workspace/snd/papersOfKIST/cycsrs/program/CYCSRS/ExternalTools/yices

# path to the folder that contains the yices binary (the binary must be named yices-smt)

export YICES2PATH=/home/sabel/workspace/snd/papersOfKIST/cycsrs/program/CYCSRS/ExternalTools/yices2

# path to the directory that contains the z3 binary (the binary must be named z3)

export Z3PATH=/home/sabel/workspace/snd/papersOfKIST/cycsrs/program/CYCSRS/ExternalTools/z3

# path to the directory that contains aprove.jar

export APROVEJARPATH=/home/sabel/workspace/snd/papersOfKIST/cycsrs/program/CYCSRS/ExternalTools/aprove

# path to the directory that contains torpacyc (the binary must be named torpacyc)

export TORPACYCPATH=/home/sabel/workspace/snd/papersOfKIST/cycsrs/program/CYCSRS/ExternalTools/torpacyc2

# path to the directory that contains ttt2 (the binary must be named ttt2)

export TTT2PATH=/home/sabel/workspace/snd/papersOfKIST/cycsrs/program/CYCSRS/ExternalTools/ttt2/ttt2

#
# VALUES
# ------ 

# maximal memory use

export MEMLIMIT=6000000

# maximal virtual memory

export VMEMLIMIT=15000000

# maximal memory for java option Xmx

export JAVAMEM=6000m

